## hedgewars 0.9.24.1-dfsg

=== debian/changelog ===
hedgewars (0.9.24.1-dfsg-4build3) disco; urgency=medium

  * No-change rebuild against latest qtbase-opensource-src

 -- Jeremy Bicha <jbicha@ubuntu.com>  Wed, 14 Nov 2018 15:23:55 -0500

hedgewars (0.9.24.1-dfsg-4build2) cosmic; urgency=medium

  * No-change rebuild for ffmpeg soname changes.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 19 Jul 2018 08:43:09 +0000

hedgewars (0.9.24.1-dfsg-4build1) cosmic; urgency=medium

  * No-change rebuild against qtbase-abi-5-11-0.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 18 Jul 2018 06:19:36 -0500

hedgewars (0.9.24.1-dfsg-4) unstable; urgency=medium

  * Rebuild against new fixed fpc  (LP: #1779648)
  * Bump std-version to 4.1.4.1, no changes required.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 02 Jul 2018 14:40:02 +0200

hedgewars (0.9.24.1-dfsg-3) unstable; urgency=medium

  * Switch to salsa.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 30 May 2018 14:10:36 +0200

hedgewars (0.9.24.1-dfsg-2) unstable; urgency=medium

  * Fix typo in copyright file
  * Drop BUILD_ENGINE_C from dependencies, now we only use fpc where
    available. The pas2c binding is not working anymore and too experimental.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 24 Apr 2018 10:11:48 +0200

hedgewars (0.9.24.1-dfsg-1) unstable; urgency=medium

  * New upstream version 0.9.24.1-dfsg
  * Revert removal of temp files, now upstream

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Apr 2018 18:34:07 +0200

=== debian/control ===
Source: hedgewars
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Dmitry E. Oboukhov <unera@debian.org>,
           Gianfranco Costamagna <locutusofborg@debian.org>
Standards-Version: 4.1.4.1
Build-Depends: cmake,
               debhelper (>= 10),
               dpkg-dev (>= 1.16.1~),
               fp-compiler,
               fp-units-misc,
               fp-units-gfx,
               freeglut3-dev,
               ghc,
# convert function
               imagemagick,
               libavcodec-dev,
               libavformat-dev,
               libghc-sandi-dev,
               libghc-entropy-dev,
               libghc-hslogger-dev,
               libghc-mtl-dev,
               libghc-network-dev,
               libghc-parsec3-dev,
               libghc-random-dev,
               libghc-regex-tdfa-dev,
               libghc-sha-dev,
               libghc-utf8-string-dev,
               libghc-vector-dev,
               libghc-zlib-dev,
               liblua5.1-dev,
               libphysfs-dev,
               libpng-dev,
               libsdl2-image-dev,
               libsdl2-mixer-dev,
               libsdl2-net-dev,
               libsdl2-ttf-dev,
               libsdl2-dev,
               qtbase5-dev,
               qtbase5-private-dev,
               qttools5-dev-tools,
               qttools5-dev,
# finding system fonts
               fonts-dejavu-core,
               fonts-wqy-zenhei
Homepage: https://hedgewars.org
Vcs-Browser: https://salsa.debian.org/games-team/hedgewars
Vcs-Git: https://salsa.debian.org/games-team/hedgewars.git

Package: hedgewars
Architecture: any
Depends: freeglut3,
         hedgewars-data (>= ${source:Upstream-Version}),
         fonts-dejavu-core,
         fonts-wqy-zenhei,
         qt5-style-plugins,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Funny turn-based artillery game, featuring fighting hedgehogs!
 Each player controls a team of several hedgehogs. During the
 course of the game, players take turns with one of their
 hedgehogs. They then use whatever tools and weapons are
 available to attack and kill the opponents' hedgehogs, thereby
 winning the game. Hedgehogs may move around the terrain in a
 variety of ways, normally by walking and jumping but also by
 using particular tools such as the "Rope" or "Parachute", to
 move to otherwise inaccessible areas. Each turn is time-limited
 to ensure that players do not hold up the game with excessive
 thinking or moving.
 .
 A large variety of tools and weapons are available for players
 during the game: Grenade, Cluster Bomb, Bazooka, UFO, Homing Bee,
 Shotgun, Desert Eagle, Fire Punch, Baseball Bat, Dynamite, Mine,
 Rope, Pneumatic pick, Parachute. Most weapons, when used, cause
 explosions that deform the terrain, removing circular chunks.
 The landscape is an island floating on a body of water, or a
 restricted cave with water at the bottom. A hedgehog dies when
 it enters the water (either by falling off the island, or
 through a hole in the bottom of it), it is thrown off either
 side of the arena or when its health is reduced, typically from
 contact with explosions, to zero (the damage dealt to the
 attacked hedgehog or hedgehogs after a player's or CPU turn is
 shown only when all movement on the battlefield has ceased).

Package: hedgewars-data
Architecture: all
Depends: ${misc:Depends}
Recommends: hedgewars
Description: Data files for hedgewars
 This package contains data files for the hedgewars package.
 Examples of files are: maps, scripts, themes, images, sounds,
 level data and other miscellaneous files needed by hedgewars.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

DEJAVU_DIRECTORY := $(shell dirname `readlink -f /usr/share/fonts/truetype/dejavu/DejaVuSans-Bold.ttf`)

HEDGEWARS_OPTIONS= \
 -DCMAKE_INSTALL_PREFIX=/usr/lib/hedgewars \
 -DDATA_INSTALL_DIR=/usr/share/games/hedgewars \
 -DCMAKE_BUILD_TYPE=RelWithDebInfo -DPHYSFS_SYSTEM=ON \
 -DFONTS_DIRS='/usr/share/fonts/truetype/wqy;$(DEJAVU_DIRECTORY)' \
 -DNOVERSIONINFOUPDATE=1

override_dh_clean:
	rm -rf tmp-icon
	dh_clean

override_dh_install:
	mv debian/tmp/usr/lib/hedgewars/share/pixmaps/ debian/tmp/usr/share/
	rm -Rf debian/tmp/usr/lib/hedgewars/share/
	# workaround dfsg repack because of #802829
	cp debian/silence.ogg debian/tmp/usr/share/games/hedgewars/Data/Sounds/Droplet1.ogg
	cp debian/silence.ogg debian/tmp/usr/share/games/hedgewars/Data/Sounds/Droplet2.ogg
	cp debian/silence.ogg debian/tmp/usr/share/games/hedgewars/Data/Sounds/Droplet3.ogg
	dh_install

override_dh_auto_configure:
	for icon in `find debian/hicolor-icons -type f`; do \
		dirname=`dirname $$icon`; \
		dirname=`dirname $$dirname`; \
		dirname=`basename $$dirname`; \
		basename=`basename $$icon .xpm`; \
		mkdir -p tmp-icon/$$dirname/apps; \
		convert $$icon +set date:create +set date:modify -define png:exclude-chunk=time tmp-icon/$$dirname/apps/$$basename.png; \
	done
	dh_auto_configure -- $(HEDGEWARS_OPTIONS)

## hedgewars 0.9.25

=== CMakeLists.txt ===
project(hedgewars)


#initialise cmake environment
cmake_minimum_required(VERSION 2.6.4)
foreach(hwpolicy CMP0003 CMP0012 CMP0017 CMP0018)
    if(POLICY ${hwpolicy})
        cmake_policy(SET ${hwpolicy} NEW)
    endif()
endforeach()

foreach(hwpolicy CMP0026 CMP0068)
    if(POLICY ${hwpolicy})
        cmake_policy(SET ${hwpolicy} OLD)
    endif()
endforeach()

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake_modules")
include(${CMAKE_MODULE_PATH}/utils.cmake)

#possible cmake configuration
option(NOSERVER "Disable gameServer build (off)" OFF)
option(NOPNG "Disable screenshoot compression (off)" OFF)
option(NOVIDEOREC "Disable video recording (off)" OFF)

#libraries are built shared unless explicitly added as a static
option(BUILD_SHARED_LIBS "Build libraries as shared modules (on)" ON)

if(WIN32 OR APPLE)
    option(LUA_SYSTEM "Use system lua (off)" OFF)
else()
    option(LUA_SYSTEM "Use system lua (on)" ON)
endif()

option(BUILD_ENGINE_LIBRARY "Enable hwengine library (off)" OFF)
option(ANDROID "Enable Android build (off)" OFF)

option(MINIMAL_FLAGS "Respect system flags as much as possible (off)" OFF)
option(NOAUTOUPDATE "Disable OS X Sparkle update checking (off)" OFF)
option(SKIPBUNDLE "Do not create relocate bundle (off)" OFF)

option(BUILD_ENGINE_C "Compile hwengine as native C (off)" OFF)
option(BUILD_ENGINE_JS "Compile hwengine as javascript (off)" OFF)
option(GL2 "Enable OpenGL 2 rendering !!!EXPERIMENTAL - DO NOT USE!!! [default: off)" OFF)

set(GHFLAGS "" CACHE STRING "Additional Haskell flags")
if(UNIX AND NOT APPLE)
    set(DATA_INSTALL_DIR "share/hedgewars" CACHE STRING "Resource folder path")
endif()

option(NOVERSIONINFOUPDATE "Disable update of version_info.txt. To be used if source is in a git/repo that is NOT the hedgewars repo" OFF)


if(BUILD_ENGINE_JS)
    if(NOT CMAKE_TOOLCHAIN_FILE)
        message(FATAL_ERROR "Missing emscripten toolchain file\nClean your cache and rerun cmake with -DCMAKE_TOOLCHAIN_FILE=${CMAKE_SOURCE_DIR}/cmake_modules/Platform/Emscripten.cmake")
    endif()

    set(BUILD_ENGINE_C ON CACHE STRING "Required for BUILD_ENGINE_JS" FORCE)
    set(BUILD_ENGINE_LIBRARY ON CACHE STRING "Required for BUILD_ENGINE_JS" FORCE)
    set(NOAUTOUPDATE ON CACHE STRING "Required for BUILD_ENGINE_JS" FORCE)
    set(LUA_SYSTEM OFF CACHE STRING "Required for BUILD_ENGINE_JS" FORCE)
    set(NOVIDEOREC ON CACHE STRING "Required for BUILD_ENGINE_JS" FORCE)
    set(NOSERVER ON CACHE STRING "Required for BUILD_ENGINE_JS" FORCE)
    set(GL2 ON CACHE STRING "Required for BUILD_ENGINE_JS" FORCE)
    set(BUILD_SHARED_LIBS OFF CACHE STRING "Required for BUILD_ENGINE_JS" FORCE)

    set(target_binary_install_dir "bin" CACHE PATH "install dest for binaries")
    set(target_library_install_dir "lib" CACHE PATH "install dest for libs")
endif()

if("${CMAKE_SIZEOF_VOID_P}" EQUAL "4" AND UNIX AND NOT APPLE)
    set(BUILD_ENGINE_C ON CACHE STRING "PAS2C force-enabled due to a freepascal 32 bit alignment bug" FORCE)
endif()
if(BUILD_ENGINE_C)
    set(NOVIDEOREC ON CACHE STRING "PAS2C does not support video recording at present" FORCE)
endif()

#system paths for finding required fonts (see share/hedgewars/Data/fonts)
#subdirectories will NOT be searched.
#all fonts that can't be found will be bundled with hedgewars
set(FONTS_DIRS "" CACHE STRING "Additional paths to folders where required fonts can be found ( ; is separator)")

#versioning
set(CPACK_PACKAGE_VERSION_MAJOR 0)
set(CPACK_PACKAGE_VERSION_MINOR 9)
set(CPACK_PACKAGE_VERSION_PATCH 25)
set(HEDGEWARS_PROTO_VER 57)
set(HEDGEWARS_VERSION "${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
include(${CMAKE_MODULE_PATH}/revinfo.cmake)

message(STATUS "Building ${HEDGEWARS_VERSION}-r${HEDGEWARS_REVISION} (${HEDGEWARS_HASH})")

#io library paths
include(${CMAKE_MODULE_PATH}/paths.cmake)
#general utilities
include(${CMAKE_MODULE_PATH}/utils.cmake)
#platform specific init code
include(${CMAKE_MODULE_PATH}/platform.cmake)


#when build type is not specified, assume Debug/Release according to build version information
if(CMAKE_BUILD_TYPE)
    string(TOUPPER ${CMAKE_BUILD_TYPE} CMAKE_BUILD_TYPE)
    if(NOT((CMAKE_BUILD_TYPE MATCHES "RELEASE") OR
           (CMAKE_BUILD_TYPE MATCHES "DEBUG") OR
           (CMAKE_BUILD_TYPE MATCHES "RELWITHDEBINFO")))
        set(CMAKE_BUILD_TYPE ${default_build_type} CACHE STRING "Build type (Debug/Release/RelWithDebInfo)" FORCE)
        message(STATUS "Unknown build type ${CMAKE_BUILD_TYPE}, using default (${default_build_type})")
    endif()
else(CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE ${default_build_type} CACHE STRING "Build type (Debug/Release/RelWithDebInfo)" FORCE)
endif(CMAKE_BUILD_TYPE)


#perform safe check that enable/disable compilation features
#skip when crosscompiling to javascript
if(NOT BUILD_ENGINE_JS)
    include(${CMAKE_MODULE_PATH}/compilerchecks.cmake)
endif()

#set default compiler flags
if(WIN32 AND VCPKG_TOOLCHAIN)
    add_flag_append(CMAKE_C_FLAGS "/DWIN32_VCPKG /Wall")
    add_flag_append(CMAKE_C_FLAGS_RELEASE "/Ox")
    add_flag_append(CMAKE_C_FLAGS_DEBUG "/Od")
    add_flag_append(CMAKE_CXX_FLAGS "/DWIN32_VCPKG /Wall")
    add_flag_append(CMAKE_CXX_FLAGS_RELEASE "/Ox")
    add_flag_append(CMAKE_CXX_FLAGS_DEBUG "/Od")    
else()
    add_flag_append(CMAKE_C_FLAGS "-Wall -pipe")
    add_flag_append(CMAKE_C_FLAGS_RELEASE "-O2")
    add_flag_append(CMAKE_C_FLAGS_DEBUG "-Wextra -O0")
    add_flag_append(CMAKE_CXX_FLAGS "-Wall -pipe")
    add_flag_append(CMAKE_CXX_FLAGS_RELEASE "-O2")
    add_flag_append(CMAKE_CXX_FLAGS_DEBUG "-Wextra -O0")    
endif()       

#CMake adds a lot of additional configuration flags, so let's clear them up
if(MINIMAL_FLAGS)
    unset(CMAKE_C_FLAGS_RELEASE)
    unset(CMAKE_C_FLAGS_DEBUG)
    unset(CMAKE_CXX_FLAGS_RELEASE)
    unset(CMAKE_CXX_FLAGS_DEBUG)
endif()


#parse additional parameters
if(GHFLAGS)
    if(${CMAKE_VERSION} VERSION_GREATER 2.6)
        separate_arguments(ghflags_parsed UNIX_COMMAND ${GHFLAGS})
    else()
        message("*** GHFLAGS are available only when using CMake >= 2.8 ***")
    endif()
endif()


#get BUILD_TYPE and enable/disable optimisation
message(STATUS "Using ${CMAKE_BUILD_TYPE} configuration")
if(CMAKE_BUILD_TYPE MATCHES "DEBUG")
    list(APPEND haskell_flags "-Wall"       # all warnings
                              "-debug"      # debug mode
                              "-fno-warn-unused-do-bind"
                              "-O0"
                              )
else()
    list(APPEND haskell_flags "-w" # no warnings
                              "-O2"
                              )
endif()


#build engine without freepascal
if(BUILD_ENGINE_C AND NOT BUILD_ENGINE_JS)
    find_package(Clang REQUIRED)

    if(${CLANG_VERSION} VERSION_LESS "3.0")
        message(FATAL_ERROR "LLVM/Clang compiler required version is 3.0 but version ${CLANG_VERSION} was found!")
    endif()

    set(CMAKE_C_COMPILER ${CLANG_EXECUTABLE})
    set(CMAKE_CXX_COMPILER ${CLANG_EXECUTABLE})
endif()


#server
if(NOT NOSERVER)
    add_subdirectory(gameServer)
endif()


#lua discovery
if(LUA_SYSTEM)
    if(NOT LUA_LIBRARY OR NOT LUA_INCLUDE_DIR)
        find_package(Lua)
    endif()

    if(LUA_LIBRARY AND LUA_INCLUDE_DIR)
        #use an IMPORTED tharget so that we can just use 'lua' to link
        add_library(lua UNKNOWN IMPORTED)
        set_target_properties(lua PROPERTIES IMPORTED_LOCATION ${LUA_LIBRARY})
    else()
        message(FATAL_ERROR "Missing Lua! Rerun cmake with -DLUA_SYSTEM=off to build the internal version")
    endif()
else()
    if(NOT LUA_LIBRARY OR NOT LUA_INCLUDE_DIR)
        message(STATUS "LUA will be provided by the bundled sources")
    endif()
    set(lua_output_name "hwlua")
    add_subdirectory(misc/liblua)
endif()


#physfs discovery
if(NOT PHYSFS_LIBRARY OR NOT PHYSFS_INCLUDE_DIR)
    find_package(PhysFS)
endif()

find_file(physfs_h physfs.h ${PHYSFS_INCLUDE_DIR})
if(physfs_h)
    file(STRINGS ${physfs_h} physfs_majorversion REGEX "PHYSFS_VER_MAJOR[\t' ']+[0-9]+")
    file(STRINGS ${physfs_h} physfs_minorversion REGEX "PHYSFS_VER_MINOR[\t' ']+[0-9]+")
    file(STRINGS ${physfs_h} physfs_patchversion REGEX "PHYSFS_VER_PATCH[\t' ']+[0-9]+")
    string(REGEX MATCH "([0-9]+)" physfs_majorversion "${physfs_majorversion}")
    string(REGEX MATCH "([0-9]+)" physfs_minorversion "${physfs_minorversion}")
    string(REGEX MATCH "([0-9]+)" physfs_patchversion "${physfs_patchversion}")
    set(physfs_detected_ver "${physfs_majorversion}.${physfs_minorversion}.${physfs_patchversion}")

    if(${physfs_detected_ver} VERSION_LESS 3.0.0)
        message(FATAL_ERROR "PhysFS version is too old (detected ${physfs_detected_ver}, required 3.0.0)\n"
                            "Perform an update of PhysFS to fix this.")
    endif()
endif()

if(PHYSFS_LIBRARY AND PHYSFS_INCLUDE_DIR)
    #use an IMPORTED tharget so that we can just use 'physfs' to link
    add_library(physfs UNKNOWN IMPORTED)
    set_target_properties(physfs PROPERTIES IMPORTED_LOCATION ${PHYSFS_LIBRARY})
else()
    message(FATAL_ERROR "Missing PhysFS! Install PhysFS to fix this.")
endif()

find_package_or_disable_msg(LIBAV NOVIDEOREC "Video recording will not be built")

#physfs helper library
add_subdirectory(misc/libphyslayer)

#maybe this could be merged inside hedgewars/CMakeLists.txt
if(BUILD_ENGINE_C)
    #pascal to c converter
    add_subdirectory(tools/pas2c)
    add_subdirectory(project_files/hwc)
else()
    #main pascal engine
    add_subdirectory(hedgewars)
endif()

#Android related build scripts
#TODO: when ANDROID, BUILD_ENGINE_LIBRARY should be set
if(ANDROID)
    add_subdirectory(project_files/Android-build)
else(ANDROID)
    #skip frontend for javascript
    if(NOT BUILD_ENGINE_JS)
        add_subdirectory(QTfrontend)
        add_subdirectory(share)
    endif()

    add_subdirectory(bin)
    add_subdirectory(tools)
endif(ANDROID)

include(${CMAKE_MODULE_PATH}/cpackvars.cmake)

enable_testing()

add_custom_target(test_normal  COMMAND ${CMAKE_CTEST_COMMAND} -E '^todo/' --timeout 300 --schedule-random)
add_custom_target(test_verbose COMMAND ${CMAKE_CTEST_COMMAND} -E '^todo/' --timeout 300 --schedule-random -V)

set(LUATESTS_DIR "${CMAKE_SOURCE_DIR}/tests/lua")
set(TESTSDATA_DIR "${CMAKE_SOURCE_DIR}/share/hedgewars/Data")

# set set this to "" if you want to see what's going on
# TODO: engine should do this implicitly when running tests,
# unless some env var like HWENGINE_SHOWTESTS is set or something
set(STATSONLYFLAG "--stats-only")

# add all lua tests
file(GLOB_RECURSE luatests RELATIVE "${LUATESTS_DIR}" "${LUATESTS_DIR}/*.lua")
foreach(luatest ${luatests})
    add_test("${luatest}" "bin/hwengine" "--prefix" "${TESTSDATA_DIR}" "--nosound" "--nomusic" "${STATSONLYFLAG}" "--lua-test" "${LUATESTS_DIR}/${luatest}")
endforeach(luatest)

=== QTfrontend/CMakeLists.txt ===
if(APPLE AND EXISTS /usr/local/opt/qt5)
	# Special treatment for OS X users who
	# install Qt5 via Homebrew.
	# Homebrew installs Qt5 (up to at least 5.9.1) in
	# /usr/local/qt5, ensure it can be found by CMake since
	# it is not in the default /usr/local prefix.
	list(APPEND CMAKE_PREFIX_PATH "/usr/local/opt/qt5")
endif()

find_package(Qt5 COMPONENTS Core Widgets Gui Network)

include_directories(${Qt5Core_PRIVATE_INCLUDE_DIRS})

include(CheckLibraryExists)

find_package(SDL2 REQUIRED)
find_package(SDL2_mixer 2 REQUIRED) #audio in SDLInteraction
include_directories(${SDL2_INCLUDE_DIR})
include_directories(${SDL2_MIXER_INCLUDE_DIRS})

if(LIBAV_FOUND)
    add_definitions(-DVIDEOREC -D__STDC_CONSTANT_MACROS)
    include_directories(${LIBAV_INCLUDE_DIR})
    list(APPEND HW_LINK_LIBS ${LIBAV_LIBRARIES})
endif()

# server messages localization
file(GLOB ServerSources ${CMAKE_SOURCE_DIR}/gameServer/*.hs)
foreach(hsfile ${ServerSources})
    file(READ ${hsfile} hs)
    string(REGEX MATCHALL "loc *\"[^\n\"]+\"" locs ${hs})
    foreach(str ${locs})
        string(REGEX REPLACE "loc *\"([^\n\"]+)\"" "QT_TRANSLATE_NOOP(\"server\", \"\\1\")" s ${str})
        list(APPEND serverlocs ${s})
    endforeach(str)
endforeach(hsfile)

list(REMOVE_DUPLICATES serverlocs)
list(GET serverlocs 0 firstline)
list(REMOVE_AT serverlocs 0)
set(locsout "const char * serverMessages[] = {\n")
foreach(l ${serverlocs})
    list(APPEND locsout ${l} ",\n")
endforeach(l)
list(APPEND locsout ${firstline} "\n}\\;\n")
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/servermessages.h ${locsout})

include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/model)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/net)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/ui)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/ui/dialog)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/ui/page)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/ui/widget)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/util)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/util/platform)
include_directories(BEFORE ${PHYSFS_INCLUDE_DIR})
include_directories(BEFORE ${PHYSLAYER_INCLUDE_DIR})
include_directories(${LUA_INCLUDE_DIR}) #brought by physlayer hwpacksmounter.h

if(UNIX)
    # HACK: in freebsd cannot find iconv.h included via SDL.h
    include_directories("/usr/local/include")
endif(UNIX)

#only the cocoa version of qt supports building 64 bit apps
if(APPLE AND (CMAKE_OSX_ARCHITECTURES MATCHES "x86_64*") AND (NOT QT_MAC_USE_COCOA))
    message(FATAL_ERROR "Building the 64 bit version of Hedgewars *requires* the Cocoa variant of QT on Mac OS X")
endif()
#endif()

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/hwconsts.cpp.in ${CMAKE_CURRENT_BINARY_DIR}/hwconsts.cpp)

file(GLOB NetCpp net/*.cpp)
file(GLOB ModelCpp model/*.cpp)
file(GLOB_RECURSE UIcpp ui/*.cpp)
file(GLOB UtilCpp util/*.cpp)

list(APPEND hwfr_src
    ${ModelCpp}
    ${NetCpp}
    ${UIcpp}
    ${UtilCpp}
    achievements.cpp
    binds.cpp
    drawmapscene.cpp
    game.cpp
    gameuiconfig.cpp
    HWApplication.cpp
    hwform.cpp
    main.cpp
    team.cpp
    campaign.cpp
    ui_hwform.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/hwconsts.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/sdlkeys.cpp
    )

if(MINGW)
    # resource compilation for mingw
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hedgewars_rc.o
                       COMMAND windres -I ${CMAKE_CURRENT_SOURCE_DIR}
                               -i ${CMAKE_CURRENT_SOURCE_DIR}/hedgewars.rc
                               -o ${CMAKE_CURRENT_BINARY_DIR}/hedgewars_rc.o)
    list(APPEND hwfr_src ${CMAKE_CURRENT_BINARY_DIR}/hedgewars_rc.o)
else(MINGW)
    list(APPEND hwfr_src hedgewars.rc)
endif(MINGW)

file(GLOB ModelHdr model/*.h)
file(GLOB NetHdr net/*.h)
file(GLOB_RECURSE UIhdr ui/*.h)
file(GLOB UtilHdr util/*.h)


set(hwfr_moc_hdrs
    ${ModelHdr}
    ${NetHdr}
    ${UIhdr}
    drawmapscene.h
    game.h
    gameuiconfig.h
    HWApplication.h
    hwform.h
    team.h
    util/DataManager.h
    util/LibavInteraction.h
    )

set(hwfr_hdrs
    ${UtilHdr}
    team.h
    achievements.h
    binds.h
    ui_hwform.h
    hwconsts.h
    sdlkeys.h
    campaign.h
    ${CMAKE_CURRENT_BINARY_DIR}/servermessages.h
    )

set(hwfr_rez hedgewars.qrc)

if(BUILD_ENGINE_LIBRARY)
    add_definitions(-DHWLIBRARY=1)
    set(hwlibname "${EXECUTABLE_OUTPUT_PATH}/${CMAKE_SHARED_LIBRARY_PREFIX}hwengine${CMAKE_SHARED_LIBRARY_SUFFIX}")
    list(APPEND HW_LINK_LIBS ${hwlibname})

    if(LIBAV_FOUND)
#        add_subdirectory(avwrapper)
        list(APPEND HW_LINK_LIBS avwrapper)
    endif()
endif()

qt5_add_resources(hwfr_rez_src ${hwfr_rez})

qt5_wrap_cpp(hwfr_moc_srcs ${hwfr_moc_hdrs})


if(APPLE)
    find_library(iokit_framework NAMES IOKit)
    list(APPEND HW_LINK_LIBS ${iokit_framework})
    list(APPEND hwfr_src util/platform/CocoaInitializer.mm
                         util/platform/InstallController.cpp
                         util/platform/M3Panel.mm
                         util/platform/M3InstallController.m
                         util/platform/NSWorkspace_RBAdditions.m
                         )
    include(${CMAKE_MODULE_PATH}/utils.cmake)
    find_package_or_disable_msg(Sparkle NOAUTOUPDATE "Autoupdater will not be built.")
    if(SPARKLE_FOUND)
        add_definitions(-DSPARKLE_ENABLED)
        list(APPEND hwfr_src util/platform/AutoUpdater.cpp
                             util/platform/SparkleAutoUpdater.mm)
        list(APPEND HW_LINK_LIBS ${SPARKLE_LIBRARY})
    endif()
endif()

#when debugging, always prompt a console to see fronted messages
#TODO: check it doesn't interfere on UNIX
if(CMAKE_BUILD_TYPE MATCHES "RELEASE" OR CMAKE_BUILD_TYPE MATCHES "RELWITHDEBINFO")
    set(console_access "WIN32")
endif(CMAKE_BUILD_TYPE MATCHES "RELEASE" OR CMAKE_BUILD_TYPE MATCHES "RELWITHDEBINFO")

add_executable(hedgewars ${console_access}
    ${hwfr_src}
    ${hwfr_moc_srcs}
    ${hwfr_hdrs}
    ${hwfr_rez_src}
    )

list(APPEND HW_LINK_LIBS
    physfs physlayer
    Qt5::Core Qt5::Widgets Qt5::Gui Qt5::Network
    )

list(APPEND HW_LINK_LIBS
    ${SDL2_LIBRARY}
    ${SDL2_MIXER_LIBRARIES}
    )

if(WIN32 AND NOT UNIX)
    if(NOT SDL2_LIBRARY)
        list(APPEND HW_LINK_LIBS SDL2)
    endif()

    list(APPEND HW_LINK_LIBS
        ole32
        oleaut32
        winspool
        uuid
        )
endif()

if(CMAKE_CXX_COMPILER MATCHES "clang*")
    list(APPEND HW_LINK_LIBS stdc++ m)
endif()

if(WIN32 AND VCPKG_TOOLCHAIN)
    list(APPEND HW_LINK_LIBS Qt5::WinMain)
endif()

target_link_libraries(hedgewars ${HW_LINK_LIBS})


install(PROGRAMS "${EXECUTABLE_OUTPUT_PATH}/hedgewars${CMAKE_EXECUTABLE_SUFFIX}" DESTINATION ${target_binary_install_dir})

=== hedgewars/CMakeLists.txt ===
enable_language(Pascal)

find_package(SDL2 REQUIRED)
find_package(SDL2_image 2 REQUIRED)
find_package(SDL2_net 2 REQUIRED)
find_package(SDL2_ttf 2 REQUIRED)
find_package(SDL2_mixer 2 REQUIRED)

include(CheckLibraryExists)
include(${CMAKE_MODULE_PATH}/utils.cmake)


enable_language(Pascal)
add_flag_append(CMAKE_Pascal_FLAGS "-Cs2000000 -B")
add_flag_append(CMAKE_Pascal_FLAGS_DEBUG "-gv")
add_flag_append(CMAKE_Pascal_FLAGS_RELEASE "-Xs")
if(UNIX)
    include(TargetArch)
    target_architecture(CMAKE_TARGET_ARCHITECTURES)
    if(${CMAKE_Pascal_COMPILER_VERSION} VERSION_GREATER 2.7 OR ${CMAKE_TARGET_ARCHITECTURES} MATCHES "x86_64" OR ${CMAKE_TARGET_ARCHITECTURES} MATCHES "i386")
        add_flag_append(CMAKE_Pascal_FLAGS "-fPIC")
    endif()
endif(UNIX)

# convert list into pascal array
if(FONTS_DIRS)
  list(LENGTH FONTS_DIRS ndirs)
  set(FONTS_DIRS_ARRAY "array [0..${ndirs}] of PChar = (")
  foreach(fontdir ${FONTS_DIRS})
      set(FONTS_DIRS_ARRAY "${FONTS_DIRS_ARRAY}\n_P'${fontdir}',")
  endforeach(fontdir)
  set(FONTS_DIRS_ARRAY "${FONTS_DIRS_ARRAY}\nnil);\n")
else(FONTS_DIRS)
  set(FONTS_DIRS_ARRAY "array [0..1] of PChar = (nil, nil);")
endif(FONTS_DIRS)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/config.inc.in ${CMAKE_CURRENT_BINARY_DIR}/config.inc)
include_directories(${CMAKE_CURRENT_BINARY_DIR})


#set the sources with the correct order of dependencies so that cmake won't be confused
set(engine_sources
    SDLh.pas
    uSinTable.pas
    uFloat.pas
    uConsts.pas
    LuaPas.pas
    uTypes.pas
    uVariables.pas
    uUtils.pas
    uMisc.pas
    uConsole.pas
    uCommands.pas
    uDebug.pas
    uInputHandler.pas
    uTextures.pas
    uRenderUtils.pas
    uRender.pas
    uCaptions.pas
    uIO.pas
    uChat.pas
    uPhysFSLayer.pas
    uSound.pas
    ArgParsers.pas
    uRandom.pas
    uLocale.pas
    uStats.pas
    uCursor.pas
    uVideoRec.pas
    uAILandMarks.pas
    adler32.pas
    uLandTemplates.pas
    uLandTexture.pas
    uLandGraphics.pas
    uLandPainted.pas
    uLandOutline.pas
    uLandGenMaze.pas
    uLandGenPerlin.pas
    uLandGenTemplateBased.pas
    uLandUtils.pas

    #this is where dependency tracking becomes hard
    uStore.pas
    uAmmos.pas
    uLandObjects.pas
    uLand.pas
    uGearsList.pas
    uCollisions.pas
    uAIMisc.pas
    uAIActions.pas
    uAIAmmoTests.pas
    uAI.pas
    uWorld.pas
    uVisualGearsList.pas
    uVisualGearsHandlers.pas
    uVisualGears.pas

    uGears.pas
    uGame.pas
    uCommandHandlers.pas
    uGearsRender.pas
    uGearsHedgehog.pas
    uGearsHandlers.pas
    uGearsHandlersRope.pas
    uGearsHandlersMess.pas
    uGearsUtils.pas
    uTeams.pas

    #these interact with everything, so compile last
    uScript.pas
    )


if(${CMAKE_Pascal_COMPILER_VERSION} VERSION_LESS 2.2 OR # older versions are just ancient
   (${CMAKE_Pascal_COMPILER_VERSION} VERSION_LESS 2.6 AND APPLE)) # because of 64bit and opengl bindings
    message(FATAL_ERROR "Your FreePascal installation is too old (fpc ${CMAKE_Pascal_COMPILER_VERSION})!")
elseif(${CMAKE_Pascal_COMPILER_VERSION} VERSION_GREATER 2.4)
    #enable INLINE only with a recent version of fpc
    add_flag_prepend(CMAKE_Pascal_FLAGS_RELEASE -Si)
endif()

#generic folder where our libraries reside
add_flag_append(CMAKE_Pascal_FLAGS "-Fl${LIBRARY_OUTPUT_PATH}")

#DEPENDECIES AND EXECUTABLES SECTION
if(APPLE AND (NOT BUILD_ENGINE_LIBRARY))
    #OpenGL deps
    add_flag_append(CMAKE_Pascal_FLAGS "-k-framework -kCocoa")
    add_flag_append(CMAKE_Pascal_FLAGS "-k-framework -kOpenGL")

    #set the correct library or framework style depending on the main SDL
    string(FIND "${SDL2_LIBRARY}" "dylib" sdl_framework)
    if(${sdl_framework} GREATER -1)
        add_flag_append(CMAKE_Pascal_FLAGS "-k-lsdl2 -k-lsdl2_image -k-lsdl2_mixer -k-lsdl2_ttf -k-lsdl2_net")
    else()
        add_flag_append(CMAKE_Pascal_FLAGS "-k-framework -kSDL2 -k-framework -kSDL2_image -k-framework -kSDL2_mixer -k-framework -kSDL2_net -k-framework -kSDL2_net -k-framework -kSDL2_ttf")
    endif()
endif()

if(LIBAV_FOUND)
    add_subdirectory(avwrapper)
    list(APPEND HW_LINK_LIBS avwrapper)
    add_definitions(-dUSE_VIDEO_RECORDING)
endif()

find_package_or_disable_msg(PNG NOPNG "Screenshots will be saved in BMP")
if(PNG_FOUND)
    list(INSERT engine_sources 0 PNGh.pas)
    list(REMOVE_AT PNG_LIBRARIES 1) #removing the zlib library path
    get_filename_component(PNG_LIBRARY_DIR ${PNG_LIBRARIES} PATH)
    add_flag_append(CMAKE_Pascal_FLAGS "-k-L${PNG_LIBRARY_DIR} -Fl${PNG_LIBRARY_DIR}")
    add_definitions(-dPNG_SCREENSHOTS)
endif()

if(LUA_SYSTEM)
    get_filename_component(LUA_LIBRARY_DIR ${LUA_LIBRARY} PATH)
    get_filename_component(LUA_LIBRARY_NAME ${LUA_LIBRARY} NAME)
    #NAME_WE would strip the .1 (or .2) next to the ".so"
    string(REGEX REPLACE "${CMAKE_SHARED_LIBRARY_PREFIX}(.*)${CMAKE_SHARED_LIBRARY_SUFFIX}" "\\1" LUA_LIBRARY_NAME "${LUA_LIBRARY_NAME}")
    add_flag_append(CMAKE_Pascal_FLAGS "-Fl${LUA_LIBRARY_DIR} -XLAlua=${LUA_LIBRARY_NAME}")
else()
    add_definitions(-dLUA_INTERNAL)
    list(APPEND HW_LINK_LIBS lua)
    add_flag_append(CMAKE_Pascal_FLAGS "-XLAlua=${lua_output_name}")
endif()

# PhysFS
get_filename_component(PHYSFS_LIBRARY_DIR ${PHYSFS_LIBRARY} PATH)
add_flag_append(CMAKE_Pascal_FLAGS "-Fl${PHYSFS_LIBRARY}")

list(APPEND HW_LINK_LIBS physlayer)


#opengl 2
IF(GL2)
    add_definitions(-dGL2)
ENDIF(GL2)

#needs to be last
add_definitions(-dDEBUGFILE)


# source files are with full path after this
set(sourcefiles_sofar "${CMAKE_CURRENT_SOURCE_DIR}/options.inc" "${CMAKE_CURRENT_BINARY_DIR}/config.inc")
foreach(loop_var ${engine_sources})
    list(APPEND sourcefiles_sofar "${CMAKE_CURRENT_SOURCE_DIR}/${loop_var}")
endforeach(loop_var)

if (WIN32 AND VCPKG_TOOLCHAIN)
    add_definitions(-dWIN32_VCPKG)
endif()


#SOURCE AND PROGRAMS SECTION
if(BUILD_ENGINE_LIBRARY)
    message("***Engine will be built as library (experimental)***")
    if(APPLE)
        if (${current_macosx_version} VERSION_GREATER "10.5")
            # due to compiler/linker issues on Max OS X 10.6 -k-no_order_inits is needed to avoid linking fail
            add_flag_prepend(CMAKE_Pascal_FLAGS "-k-no_order_inits")
        endif()
    endif()

    #workaround for missing <TARGET> support during object generation
    set(engine_output_name "${CMAKE_SHARED_LIBRARY_PREFIX}hwengine${CMAKE_SHARED_LIBRARY_SUFFIX}")
    set(destination_dir ${target_library_install_dir})
    add_flag_prepend(CMAKE_Pascal_FLAGS "-o${LIBRARY_OUTPUT_PATH}/${engine_output_name}")

    add_definitions(-dHWLIBRARY)
    set_source_files_properties(hwLibrary.pas PROPERTIES OBJECT_DEPENDS "${sourcefiles_sofar};${CMAKE_CURRENT_SOURCE_DIR}/hwengine.pas")
    add_library(hwengine SHARED hwLibrary.pas)
else()
    # no need to change name here because target has same name
    set(engine_output_name "hwengine${CMAKE_EXECUTABLE_SUFFIX}")
    set(destination_dir ${target_binary_install_dir})
    set_source_files_properties(hwengine.pas PROPERTIES OBJECT_DEPENDS "${sourcefiles_sofar}")
    add_executable(hwengine hwengine.pas)
endif()

#even though not actually used, this will trigger relink if any lib changes
target_link_libraries(hwengine ${HW_LINK_LIBS})

install(PROGRAMS "${EXECUTABLE_OUTPUT_PATH}/${engine_output_name}" DESTINATION ${destination_dir})

=== tools/CMakeLists.txt ===
if(NOT APPLE)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
                    IMMEDIATE @ONLY)

    add_custom_target(uninstall "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif()

if(APPLE AND NOT SKIPBUNDLE)
    find_package(Qt5 REQUIRED QUIET COMPONENTS Core Widgets Gui Network)
    find_package(SDL2 REQUIRED)
    find_package(SDL2_image 2 REQUIRED)
    find_package(SDL2_net 2 REQUIRED)
    find_package(SDL2_ttf 2 REQUIRED)
    find_package(SDL2_mixer 2 REQUIRED)
    find_package(OggVorbis REQUIRED)
    find_package(PNG REQUIRED)

    if(NOT NOAUTOUPDATE)
        find_package(Sparkle) #needed for SPARKLE_FOUND variable
        #needed because the 'if' clause in the script prints silly policy warnings
        if(SPARKLE_FOUND)
            set(SPARKLE_FOUND 1)
        else()
            set(SPARKLE_FOUND 0)
        endif()
    endif()

    #use the associated tool from the libraries we've selected
    string(REGEX REPLACE "(.*)/include.*" "\\1" qt_base_dir "${QT_INCLUDE_DIR}")

    #remove the ";-framework Cocoa" from the SDL2_LIBRARY variable
    string(REGEX REPLACE "(.*);-.*" "\\1" sdl_library_only "${SDL2_LIBRARY}")
    #remove the "libSDLmain.a" from the SDL2_LIBRARY variable
    string(REGEX REPLACE ".*;(.*)" "\\1" sdl_library_only "${sdl_library_only}")

    #get the neme of the library (harmelss if it is static)
    string(REGEX REPLACE ".*/(.*)$" "\\1" PNG_LIBNAME "${PNG_LIBRARY}")
    string(REGEX REPLACE ".*/(.*)$" "\\1" ZLIB_LIBNAME "${ZLIB_LIBRARY}")

    set(frameworks_dir ${CMAKE_INSTALL_PREFIX}/${target_library_install_dir})
    if(${BUILD_ENGINE_LIBRARY})
        set(engine_full_path "${frameworks_dir}/${CMAKE_SHARED_LIBRARY_PREFIX}hwengine${CMAKE_SHARED_LIBRARY_SUFFIX}")
    else()
        set(engine_full_path "${CMAKE_INSTALL_PREFIX}/hwengine${CMAKE_EXECUTABLE_SUFFIX}")
    endif()

    #this tool is present in qt 4.5 but only if you compile from sources
    #from qt 4.6 is present also in the binary version
    find_program(macdeployqt_executable NAMES macdeployqt macdeployqt-mac PATHS ${qt_base_dir}/bin)
    if(NOT macdeployqt_executable)
        message(FATAL_ERROR "The utility macdeployqt is required to create the bundle (seached: ${qt_base_dir})")
    endif()

    #create the .app bundle
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/CreateMacBundle.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/CreateMacBundle.cmake)
    install(SCRIPT ${CMAKE_CURRENT_BINARY_DIR}/CreateMacBundle.cmake
            CODE "message(STATUS \"Your app bundle is ready\")")

    #create the .dmg for deployment
    #first make sure .app exists, then remove any old .dmg with same name, finally run the script
    add_custom_target(dmg COMMAND make install
                          COMMAND rm -f ${CMAKE_BINARY_DIR}/Hedgewars-${HEDGEWARS_VERSION}.dmg
                          COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/create-dmg.sh
                                  --volname "Hedgewars ${HEDGEWARS_VERSION}"
                                # --volicon icon.icns
                                  --window-size 600 470
                                  --icon-size 96
                                  --icon "Hedgewars" 190 190
                                  --app-drop-link 410 190
                                  --background "${CMAKE_CURRENT_SOURCE_DIR}/../misc/dmgBackground.png"
                                  ${CMAKE_BINARY_DIR}/Hedgewars-${HEDGEWARS_VERSION}.dmg
                                  ${CMAKE_BINARY_DIR}/Hedgewars.app
                          WORKING_DIRECTORY ${CMAKE_BINARY_DIR})
endif()

=== share/hedgewars/Data/Locale/CMakeLists.txt ===
find_package(Qt5 COMPONENTS LinguistTools)

file(GLOB txttrans2 ??.txt)
file(GLOB txttrans5 ?????.txt)
file(GLOB tsfiles *.ts)
file(GLOB luafiles *.lua)
file(GLOB missionfiles missions_*.txt)
file(GLOB campaignfiles campaigns_*.txt)
file(GLOB tipfiles tips_*.xml)

QT5_ADD_TRANSLATION(QM ${tsfiles})

add_custom_target (release-translation ALL
        DEPENDS ${QM}
        COMMENT "Compiling ts files"
)

install(FILES
    ${txttrans2}
    ${txttrans5}
    ${QM}
    ${luafiles}
    ${missionfiles}
    ${campaignfiles}
    ${tipfiles}
    DESTINATION ${SHAREPATH}Data/Locale
)

=== share/hedgewars/Data/Names/CMakeLists.txt ===
file(GLOB txtnames *.txt)
file(GLOB cfgnames *.cfg)

install(FILES
    types.ini
    ${txtnames}
    ${cfgnames}
    DESTINATION ${SHAREPATH}Data/Names)

=== share/hedgewars/Data/Maps/BasketballField/CMakeLists.txt ===
install(FILES
    map.png
    map.cfg
    mask.png
    preview.png
    DESTINATION ${SHAREPATH}Data/Maps/BasketballField)

=== share/hedgewars/Data/Maps/Bubbleflow/CMakeLists.txt ===
install(FILES
    map.png
    map.cfg
    preview.png
    DESTINATION ${SHAREPATH}Data/Maps/Bubbleflow)

=== share/hedgewars/Data/Maps/ClimbHome/CMakeLists.txt ===
install(FILES
    mask.png
    map.cfg
    map.lua
    preview.png
    desc.txt
    DESTINATION ${SHAREPATH}Data/Maps/ClimbHome)

=== share/hedgewars/Data/Maps/Mushrooms/CMakeLists.txt ===
install(FILES
    map.png
    mask.png
    map.cfg
    preview.png
    credits.txt
    DESTINATION ${SHAREPATH}Data/Maps/Mushrooms)

=== share/hedgewars/Data/Missions/Campaign/CMakeLists.txt ===
add_subdirectory("A_Classic_Fairytale")
add_subdirectory("A_Space_Adventure")

file(GLOB Scripts *.lua)

install(FILES
    ${Scripts}
    DESTINATION ${SHAREPATH}Data/Missions/Campaign)

=== share/hedgewars/Data/Themes/Bath/CMakeLists.txt ===
file(GLOB images *.png)

install(FILES
    theme.cfg
    ${images}
    DESTINATION ${SHAREPATH}Data/Themes/Bath)

=== debian/changelog ===
hedgewars (0.9.25-3) unstable; urgency=medium

  * Reduce parallelism on mips and mipsel
  * Add atomic to clang link flags, to fix a FTBFS on armel
  * debian/patches/a32b967f1341.patch:
    - upstream fix for a crash with 32bit builds (video recording)
  * Bump std-version to 4.3.0, no changes required

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 14 Dec 2018 17:25:50 +0100

hedgewars (0.9.25-2) unstable; urgency=medium

  * d/p/{2ab312c47dc3,c2a3d15df7d3,40dd8eb60d54,2841325495e,a7769dbd7088}.patch
    - cherry-pick upstream fixes for 32bit builds, and other bugfixes

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 05 Dec 2018 16:06:33 +0100

hedgewars (0.9.25-1) unstable; urgency=medium

  * Upload to unstable
  * Add armel to engine_c archs
  * Bump std-version to 4.2.1, no changes required

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 04 Dec 2018 13:35:19 +0100

hedgewars (0.9.25-1~exp1) experimental; urgency=medium

  * Remove repack from next upload, the droplet is DFSG again
  * Sync control file with hedgewars-nightly repo
  * New upstream version 0.9.25
  * update copyright file for new release
    - fixup copyright typo
  * Drop freeglut from debian/control, it seems to be not used anymore
  * drop pas2c dependencies, we don't build it anymore
  * add some new haskell dependencies for server build (aeson, text, yaml)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 03 Dec 2018 20:51:16 +0100

=== debian/control ===
--- 
+++ 
@@ -4,31 +4,35 @@
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Dmitry E. Oboukhov <unera@debian.org>,
            Gianfranco Costamagna <locutusofborg@debian.org>
-Standards-Version: 4.1.4.1
+Standards-Version: 4.3.0
 Build-Depends: cmake,
+               clang [armel armhf i386 mips mipsel],
                debhelper (>= 10),
                dpkg-dev (>= 1.16.1~),
-               fp-compiler,
-               fp-units-misc,
-               fp-units-gfx,
-               freeglut3-dev,
+               fp-compiler [!armel !armhf !i386 !mips !mipsel],
+               fp-units-misc [!armel !armhf !i386 !mips !mipsel],
+               fp-units-gfx [!armel !armhf !i386 !mips !mipsel],
                ghc,
 # convert function
                imagemagick,
                libavcodec-dev,
                libavformat-dev,
-               libghc-sandi-dev,
+               libghc-aeson-dev,
                libghc-entropy-dev,
                libghc-hslogger-dev,
                libghc-mtl-dev,
                libghc-network-dev,
-               libghc-parsec3-dev,
+               libghc-parsec3-dev [armel armhf i386 mips mipsel],
                libghc-random-dev,
                libghc-regex-tdfa-dev,
+               libghc-sandi-dev,
                libghc-sha-dev,
+               libghc-text-dev,
                libghc-utf8-string-dev,
                libghc-vector-dev,
+               libghc-yaml-dev,
                libghc-zlib-dev,
+               libglew-dev [armel armhf i386 mips mipsel],
                liblua5.1-dev,
                libphysfs-dev,
                libpng-dev,
@@ -50,8 +54,7 @@
 
 Package: hedgewars
 Architecture: any
-Depends: freeglut3,
-         hedgewars-data (>= ${source:Upstream-Version}),
+Depends: hedgewars-data (>= ${source:Upstream-Version}),
          fonts-dejavu-core,
          fonts-wqy-zenhei,
          qt5-style-plugins,

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,13 @@
 
 %:
 	dh $@
+
+ifeq ($(DEB_HOST_ARCH),mips)
+  export DEB_BUILD_OPTIONS=parallel=2
+endif
+ifeq ($(DEB_HOST_ARCH),mipsel)
+  export DEB_BUILD_OPTIONS=parallel=2
+endif
 
 DEJAVU_DIRECTORY := $(shell dirname `readlink -f /usr/share/fonts/truetype/dejavu/DejaVuSans-Bold.ttf`)
 
@@ -19,10 +26,6 @@
 override_dh_install:
 	mv debian/tmp/usr/lib/hedgewars/share/pixmaps/ debian/tmp/usr/share/
 	rm -Rf debian/tmp/usr/lib/hedgewars/share/
-	# workaround dfsg repack because of #802829
-	cp debian/silence.ogg debian/tmp/usr/share/games/hedgewars/Data/Sounds/Droplet1.ogg
-	cp debian/silence.ogg debian/tmp/usr/share/games/hedgewars/Data/Sounds/Droplet2.ogg
-	cp debian/silence.ogg debian/tmp/usr/share/games/hedgewars/Data/Sounds/Droplet3.ogg
 	dh_install
 
 override_dh_auto_configure:
